/******************************/
/********** IMPORTS **********/
/******************************/

@import url( "https://fonts.googleapis.com/css?family=IBM+Plex+Mono|PT+Sans|Solway&display=swap" );

/******************************/
/******** VENDORS:10 **********/
/******************************/

/******************************/
/********* VARIABLES **********/
/******************************/

:root{
	/* SIZES */
	--size-base: 10px;
	--size-min-width: 25rem;

	--size-radius: 3px;
	--size-large-radius: 9px;

	--size-default-text: 1.6rem;
	--size-small-text: 1.3rem;

	--size-default-line-height: 2.2rem;

	--size-tiny-padding: 0.25rem;
	--size-default-padding: 1rem;
	--size-large-padding: 2rem;


	/* COLORS */
	--color-nearly-black: hsla( 0, 0%, 9.4%, 1 );
	--color-code-block: hsla( 0, 0%, 33.3%, 1 );
	--color-strut: hsla( 0, 0%, 73.3%, 1 );
	--color-dim: hsla( 0, 0%, 43.1%, 1 );
	--color-super-dim: hsla( 0, 0%, 80.4%, 1 );
	--color-code-text: hsla( 0, 0%, 86.3%, 1 );

	--color-twitter: hsla( 202.8, 89.1%, 53.1%, 1 );

	--color-brightest: hsla( 0, 0%, 100%, 1 );
	--color-darkest: hsla( 0, 0%, 0%, 1 );

	--color-text: hsla( 0, 0%, 14.9%, 1 );
	--color-text-faded: hsla( 0, 0%, 52.9%, 1 );

	--color-strut-input: hsla( 0, 0%, 68.6%, 1 );
	--color-strut-focus: hsla( 198, 100%, 41.8%, 1 );

	--color-neutral: hsla( 0, 0%, 80%, 1 );
	--color-okay: hsla( 120.7, 40.6%, 39.6%, 1 );
	--color-info: hsla( 212.3, 60.6%, 49.8%, 1 );
	--color-alert: hsla( 0, 55.6%, 46.9%, 1 );
	--color-attention: hsla( 41.1, 68.2%, 58%, 1 );

	--color-neutral-subtle: hsla( 0, 0%, 94.1%, 1 );
	--color-okay-subtle: hsla( 122.7, 100%, 95.7%, 1 );
	--color-info-subtle: hsla( 213.6, 100%, 95.1%, 1 );
	--color-alert-subtle: hsla( 0, 100%, 95.7%, 1 );
	--color-attention-subtle: hsla(40, 100%, 94.7%, 1);

	--color-neutral-trans: hsla(0, 0%, 80%, 0.25 );
	--color-okay-trans: hsla(120.7, 40.6%, 39.6%, 0.25 );
	--color-info-trans: hsla(212.3, 60.6%, 49.8%, 0.25 );
	--color-alert-trans: hsla(0, 55.6%, 46.9%, 0.25 );
	--color-attention-trans: hsla( 41.1, 68.2%, 58%, 0.25 );

	--vfx-global-transition: all 0.1s ease-in-out;

	--vfx-shadow-block-default: 0 4px 4px -3px hsla( 0, 0%, 0%, 0.5 );
	--vfx-shadow-block-reduced: 0 2px 2px -2px hsla( 0, 0%, 0%, 0.5 );
	--vfx-left-shadow-block-default: -4px 0 4px -3px hsla( 0, 0%, 0%, 0.5 );
	--vfx-left-shadow-block-reduced: -2px 0 2px -2px hsla( 0, 0%, 0%, 0.5 );
	--vfx-right-shadow-block-reduced: 2px 0 2px -2px hsla( 0, 0%, 0%, 0.5 );
	--vfx-right-shadow-block-default: 4px 0 4px -3px hsla( 0, 0%, 0%, 0.5 );
}

/******************************/
/***** STANDARD ELEMENTS ******/
/******************************/

html{
	box-sizing: border-box;
    font-size: var( --size-base );
    line-height: calc( 1.5 * var( --size-base ) );
}

html *{
	box-sizing: inherit;
}

body{
	color: var( --color-nearly-black );
	font-family: "PT Sans", sans-serif;
    font-size: 1.8rem;
	line-height: 3.2rem;
	min-width: var( --size-min-width );
}

section{
	padding: 0 2.5rem;
}

h1,
h2,
h3,
h4{
    font-family: "Solway", serif;
	line-height: 1.2em;
	margin: 0;
	padding: 0;
}

section h2{
	margin-left: -2.5rem;
}

h1{
	font-size: 4rem;
}

h1 a{
	color: inherit;
	text-decoration: none;
}

blockquote{
	background-color: var( --color-super-dim );
	border-left: 0.5rem dashed var( --color-strut );
	padding-left: 1.5rem;
	position: relative;
}

blockquote::before{
	color: var( --color-super-dim );
	content: '“';
	font-size: 10rem;
	position: absolute;
	right: calc( 100% + 1rem );
	top: 3rem;
}

blockquote .author{
	display: block;
	margin-right: 1.5rem;
	text-align: right;
}

aside{
	border: 1px dashed var( --color-strut );
	border-radius: 1rem;
	font-family: monospace;
	font-size: 1.2rem;
	line-height: 1.4rem;
	margin: auto auto 1.5rem 30%;
	padding: 1rem;
	position: relative;
	text-align: center;
}

aside::before,
aside::after{
	color: var( --color-strut );
	font-size: 9rem;
	position: absolute;
	top: 2rem;
}

aside::before{
	content: "(";
	right: 100%;
}

aside::after{
	content: ")";
	left: 100%;
}

figure img{
	display: block;
	margin: auto;
	max-width: 100%;
}

figure figcaption{
	color: var( --color-code-block );
	text-align: center;
}

pre{
	font-size: 0.75em;
	line-height: 1.25em;
}

code{
	font-family: "IBM Plex Mono", monospace;
}

table{
	border: 1px solid hsla( 0, 0%, 85%, 1 );
	width: 100%;
}

tr:hover,
tr:focus{
	background-color: hsla( 0, 0%, 95%, 1 );
}

tr + tr{
	border-top: 1px solid hsla( 0, 0%, 85%, 1 );
}

td{
	padding: 0 0.5rem;
}

td + td{
	border-left: 1px solid hsla( 0, 0%, 85%, 1 );
}

/******************************/
/*********** TABLES ***********/
/******************************/

label.table-label{
	background-color: hsla( 0, 0%, 95%, 1 );
	border: 1px solid hsla( 0, 0%, 85%, 1 );
	border-bottom: 0;
	border-top-left-radius: 1rem;
	border-top-right-radius: 1rem;
	display: inline-block;
	font-family: "IBM Plex Mono", monospace;
	font-weight: bold;
	padding: 0 2rem;
}

table + label.table-label{
	margin-top: 3rem;
}

/******************************/
/*********** CODE *************/
/******************************/

.post code:not(.hljs){
	background-color: hsla( 0, 0%, 82.7%, 1 );
	border: 1px solid hsla( 0, 0%, 70%, 1 );
	padding: 0 0.5rem;
}

/******************************/
/****** HELPER CLASSES ********/
/******************************/

.discourage-copy{
	user-select: none;
}

/******************************/
/********** REGIONS ***********/
/******************************/

/******************************/
/********** HEADER ************/
/******************************/

body > header:first-of-type{
	background-color: var( --color-brightest );
	display: grid;
	font-size: 3rem;
	grid-template-columns: 1fr 1fr;
	height: 5rem;
	line-height: 5rem;
	padding: 0 1.5rem;
	position: sticky;
	text-align: left;
	top: 0;
	z-index: 5;
}

body > header:first-of-type a{
	color: inherit;
	text-decoration: none;
}

body > header:first-of-type > span{
	text-align: right;
	white-space: nowrap;
}

@media screen and ( min-width: 500px ){
	body > header:first-of-type{
		background: linear-gradient(
			90deg,
			hsla( 0, 0%, 100%, 1 ) 0%,
			hsla( 0, 0%, 100%, 0 ) 40%,
			hsla( 0, 0%, 100%, 0 ) 90%,
			hsla( 0, 0%, 100%, 1 ) 100%
		);
	}
}

/******************************/
/*********** VIEW *************/
/******************************/

body > .view{
	margin: auto;
	max-width: 90rem;
	min-height: calc( 100vh - 9rem );
	padding: 1rem;
	width: 95%;
}

body > .view.bookshelf{
	max-width: 150rem;
}

/******************************/
/******* INDEX VIEW ***********/
/******************************/

.view.index{
	display: grid;
	grid-row-gap: 1.5rem;
	grid-template-areas:
		"head"
		"long"
		"short";
	grid-template-columns: 1fr;
}

.view.index > .head{
	border-bottom: 5px dotted var( --color-strut );
	display: grid;
	grid-area: head;
	grid-gap: 1rem;
	grid-template-columns: 10rem 1fr;
	padding-bottom: 1rem;
	place-items: center;
}

.view.index > .head img{
	border-radius: 50%;
	max-height: 100%;
	max-width: 100%;
}

.view.index > .long{
	grid-area: long;
}

.view.index > .short{
	grid-area: short;
}

.view.index > .long + .short{
	border-top: 1px dashed var( --color-strut );
    margin-top: 0.5rem;
    padding-top: 2.5rem;
}

@media screen and ( min-width: 500px ){
	.view.index{
		grid-template-areas:
			"head long"
			"short long";
		grid-template-columns: 30% 70%;
		grid-template-rows: 18.6rem auto;
	}

	.view.index > .head{
		border-bottom: 0;
		grid-template-columns: 1fr;
		grid-template-rows: 10rem 1fr;
	}

	.view.index > .head h1{
		font-size: 2rem;
		text-align: center;
	}

	.view.index > .long{
		border-left: 0.5rem solid var( --color-info );
		margin-left: 1rem;
		padding-left: 1rem;
	}

	.view.index > .long + .short{
		border-top: 0;
		margin-top: 0;
		padding-top: 0;
	}
}

/******************************/
/****** BOOKSHELF VIEW ********/
/******************************/

.view.bookshelf{
	display: grid;
	grid-row-gap: 1.5rem;
	grid-template-areas:
		"head"
		"books";
	grid-template-columns: 1fr;
}

.view.bookshelf > .head{
	border-bottom: 5px dotted var( --color-strut );
	display: grid;
	grid-area: head;
	grid-gap: 1rem;
	grid-template-columns: 10rem 1fr;
	padding-bottom: 1rem;
	place-items: center;
}

.view.bookshelf > .head img{
	border-radius: 50%;
	max-height: 100%;
	max-width: 100%;
}

.view.bookshelf > .books{
	display: grid;
	grid-area: books;
	grid-gap: 1.5rem;
	grid-template-columns: repeat( auto-fit, minmax( 15rem, 1fr ) );
}

.view.bookshelf > .books h2{
	grid-column: 1 / -1;
}

@media screen and ( min-width: 500px ){
	.view.bookshelf{
		grid-template-areas:
			"head books"
			".    books";
		grid-template-columns: 12rem 1fr;
		grid-template-rows: max-content auto;
	}

	.view.bookshelf > .head{
		border-bottom: 0;
		grid-template-columns: 1fr;
		grid-template-rows: 10rem 1fr;
	}

	.view.bookshelf > .head h1{
		font-size: 2rem;
		text-align: center;
	}

	.view.bookshelf > .books{
		border-left: 0.5rem solid var( --color-info );
		grid-template-columns: repeat( auto-fit, minmax( 25rem, 1fr ) );
		margin-left: 1rem;
		padding-left: 1rem;
	}
}

/******************************/
/********** FOOTER ************/
/******************************/

body > footer{
	display: grid;
	grid-template-columns: 10.9rem 1fr;
	height: 4rem;
	line-height: 1;
	padding: 0 1.5rem;
	text-align: right;
}

body > footer a{
	display: inline-block;
}

body > footer a img{
	display: block;
	height: 3.2rem;
}

/******************************/
/****** CUSTOM ELEMENTS *******/
/******************************/

/******************************/
/********** BYLINE ************/
/******************************/

by-line{
	display: block;
}

.author.byline{
	align-items: center;
	display: grid;
	grid-template-areas:
		"picture author"
		"picture date";
	grid-template-columns: 5rem 1fr;
	grid-template-rows: 1fr 1fr;
	line-height: 1rem;
}

.author.byline img{
	border-radius: 50%;
	grid-area: picture;
	height: 4rem;
	width: 4rem;
}

.author.byline h3{
	grid-area: author;
}

.author.byline span{
	grid-area: date;
}

.author.byline.slim{
	grid-gap: 1rem;
	grid-template-areas: "picture author date";
	grid-template-columns: 2rem fit-content( 25rem ) 1fr;
	grid-template-rows: 1fr;
	padding: 0;
}

.author.byline.slim img{
	height: 2rem;
	margin-left: 0.25rem;
	width: 2rem;
}

.author.byline.slim h3,
.author.byline.slim span{
	font-size: 1.5rem;
}

/******************************/
/********** AUTHOR ************/
/******************************/
x-author{
	color: inherit;
	display: inline-block;
	height: 100%;
}

x-author > div{
	display: inline-block;
	height: 100%;
}

x-author a{
	display: inline-flex;
	height: 100%;
}

x-author img{
	align-self: center;
	border-radius: 1em;
	display: inline-block;
	height: 100%;
	margin-right: 0.5rem;
}

/******************************/
/******* REPLY CONNECT ********/
/******************************/

reply-connect{
	color: var( --color-super-dim );
	display: block;
	font-size: 0.8em;
	padding-bottom: 0.25rem;
}

reply-connect p{
	font-size: 100%;
	line-height: 1;
	margin: 0;
}

reply-connect p a{
	color: var( --color-dim );
}

/******************************/
/******** ALL POSTS ***********/
/******************************/

long-post-summary,
short-post,
image-short-post{
	display: block;
}

long-post-summary + long-post-summary,
short-post + short-post,
image-short-post + image-short-post,

long-post-summary + short-post,
long-post-summary + image-short-post,

short-post + long-post-summary,
image-short-post + long-post-summary,

short-post + image-short-post,
image-short-post + short-post{
    border-top: 1px dashed var( --color-strut );
    margin-top: 2.5rem;
    padding-top: 2.5rem;
}

short-post + short-post,
image-short-post + short-post,
short-post + image-short-post,
image-short-post + image-short-post{
	margin-top: 1rem;
	padding-top: 1rem;
}

/******************************/
/******** LONG POST ***********/
/******************************/

.long.post{
    padding-left: 2.5rem;
}

.long.post > h1,
.long.post > h2,
.long.post > h3{
    margin-left: -2rem;
}

.long.post > by-line{
    margin-left: -2rem;
    padding: 1.5rem;
    padding-left: 0;
}

.long.post > by-line h3{
    font-family: inherit;
    margin-left: 0;
}

.long.post > by-line + section{
    border-top: 1px solid var( --color-strut );
    padding-top: 1.5rem;
}

.long.post.summary > by-line{
	margin-left: 0;
	padding: 0;
}

.long.post.summary h1{
	font-size: 3rem;
}

/******************************/
/******** SHORT POST **********/
/******************************/

.short.post .meta{
	color: var( --color-dim );
	display: flex;
	font-size: 0.65em;
	line-height: 1.7rem;
}

.short.post:not(.summary) .meta{
	height: 1.7rem;
}

.short.post .meta{
	margin-bottom: 0.5rem;
}

.short.post .meta a{
	color: inherit;
	text-decoration: none;
}

.short.post .meta a:hover,
.short.post .meta a:focus{
	text-decoration: underline;
}

.short.post .body{
	position: relative;
}

.short.post .reply.body{
	padding-left: 0.6rem;
}

.short.post .reply.body::before{
	color: var( --color-super-dim );
	content: "⎣";
	left: 0;
	position: absolute;
	top: -1rem;
}

/******************************/
/***** IMAGE SHORT POST *******/
/******************************/

.short.post.image{
	display: grid;
	grid-template-areas:
		"meta"
		"body"
		"images"
	;
	grid-template-rows: 2.2rem fit-content( 1.5rem ) 1fr;
}

.short.post.image.reply{
	grid-template-areas:
		"meta"
		"reply"
		"body"
		"images"
	;
	grid-template-rows: 2.2rem 1.75rem fit-content( 1.5rem ) 1fr;
}

.short.post.image > .meta{
	grid-area: meta;
}

.short.post.image > reply-connect{
	grid-area: reply;
}

.short.post.image > .images{
	grid-area: images;
}

.short.post.image > .body{
	grid-area: body;
}

.short.post .images{
	align-items: center;
	display: grid;
	grid-gap: 1rem;
	grid-template-columns: repeat( auto-fill, minmax( 15rem, 1fr ) );
	justify-content: space-evenly;
	justify-items: unset;
	padding-top: 0.5rem;
}

.short.post.summary .images{
	grid-gap: unset;
	grid-template-columns: repeat( auto-fill, minmax( 10rem, 1fr ) );
	place-items: center;
}

.short.post > .images img{
	display: block;
	max-height: 100%;
	max-width: 100%;
	width: auto;
}

.short.post.summary > .images img{
	max-height: 10rem;
	max-width: 9rem;
}

/******************************/
/*********** BOOK *************/
/******************************/
.book{
	display: grid;
	grid-template-areas:
		"img"
		"title"
		"authors"
	;
	grid-template-rows: 15rem fit-content( 1em ) 1fr;
	place-items: center;
	text-align: center;
}

.book img{
	grid-area: img;
	max-height: 100%;
	max-width: 100%;
}

.book h3{
	border-bottom: 1px solid var( --color-strut );
	display: grid;
	grid-area: title;
	margin-bottom: 1rem;
	padding-bottom: 0.5rem;
}

.book h4{
	display: grid;
	grid-area: authors;
}

@media screen and ( max-width: 369px ){
	.book{
		grid-template-areas:
			"img title"
			"img authors"
		;
		grid-template-rows: fit-content( 1em ) 1fr;
		grid-template-columns: 45% 55%;
		place-items: initial;
	}
}

/******************************/
/*********** ICON *************/
/******************************/

.icon svg{
	height: 1em;
	line-height: 1em;
	width: 1em;
}
